// Generated by using Rcpp::compileAttributes() -> do not edit by hand
// Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#ifndef RCPP_halton_RCPPEXPORTS_H_GEN_
#define RCPP_halton_RCPPEXPORTS_H_GEN_

#include <RcppArmadillo.h>
#include <Rcpp.h>

namespace halton {

    using namespace Rcpp;

    namespace {
        void validateSignature(const char* sig) {
            Rcpp::Function require = Rcpp::Environment::base_env()["require"];
            require("halton", Rcpp::Named("quietly") = true);
            typedef int(*Ptr_validate)(const char*);
            static Ptr_validate p_validate = (Ptr_validate)
                R_GetCCallable("halton", "_halton_RcppExport_validate");
            if (!p_validate(sig)) {
                throw Rcpp::function_not_exported(
                    "C++ function with signature '" + std::string(sig) + "' not found in halton");
            }
        }
    }

    inline arma::vec getPrimes(int n) {
        typedef SEXP(*Ptr_getPrimes)(SEXP);
        static Ptr_getPrimes p_getPrimes = NULL;
        if (p_getPrimes == NULL) {
            validateSignature("arma::vec(*getPrimes)(int)");
            p_getPrimes = (Ptr_getPrimes)R_GetCCallable("halton", "_halton_getPrimes");
        }
        RObject rcpp_result_gen;
        {
            RNGScope RCPP_rngScope_gen;
            rcpp_result_gen = p_getPrimes(Shield<SEXP>(Rcpp::wrap(n)));
        }
        if (rcpp_result_gen.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (Rcpp::internal::isLongjumpSentinel(rcpp_result_gen))
            throw Rcpp::LongjumpException(rcpp_result_gen);
        if (rcpp_result_gen.inherits("try-error"))
            throw Rcpp::exception(Rcpp::as<std::string>(rcpp_result_gen).c_str());
        return Rcpp::as<arma::vec >(rcpp_result_gen);
    }

    inline NumericVector hseq(int H, int prime = 3, int burn = 30) {
        typedef SEXP(*Ptr_hseq)(SEXP,SEXP,SEXP);
        static Ptr_hseq p_hseq = NULL;
        if (p_hseq == NULL) {
            validateSignature("NumericVector(*hseq)(int,int,int)");
            p_hseq = (Ptr_hseq)R_GetCCallable("halton", "_halton_hseq");
        }
        RObject rcpp_result_gen;
        {
            RNGScope RCPP_rngScope_gen;
            rcpp_result_gen = p_hseq(Shield<SEXP>(Rcpp::wrap(H)), Shield<SEXP>(Rcpp::wrap(prime)), Shield<SEXP>(Rcpp::wrap(burn)));
        }
        if (rcpp_result_gen.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (Rcpp::internal::isLongjumpSentinel(rcpp_result_gen))
            throw Rcpp::LongjumpException(rcpp_result_gen);
        if (rcpp_result_gen.inherits("try-error"))
            throw Rcpp::exception(Rcpp::as<std::string>(rcpp_result_gen).c_str());
        return Rcpp::as<NumericVector >(rcpp_result_gen);
    }

    inline NumericVector hunif(int H, double min = 0, double max = 1, int prime = 3, int burn = 30) {
        typedef SEXP(*Ptr_hunif)(SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_hunif p_hunif = NULL;
        if (p_hunif == NULL) {
            validateSignature("NumericVector(*hunif)(int,double,double,int,int)");
            p_hunif = (Ptr_hunif)R_GetCCallable("halton", "_halton_hunif");
        }
        RObject rcpp_result_gen;
        {
            RNGScope RCPP_rngScope_gen;
            rcpp_result_gen = p_hunif(Shield<SEXP>(Rcpp::wrap(H)), Shield<SEXP>(Rcpp::wrap(min)), Shield<SEXP>(Rcpp::wrap(max)), Shield<SEXP>(Rcpp::wrap(prime)), Shield<SEXP>(Rcpp::wrap(burn)));
        }
        if (rcpp_result_gen.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (Rcpp::internal::isLongjumpSentinel(rcpp_result_gen))
            throw Rcpp::LongjumpException(rcpp_result_gen);
        if (rcpp_result_gen.inherits("try-error"))
            throw Rcpp::exception(Rcpp::as<std::string>(rcpp_result_gen).c_str());
        return Rcpp::as<NumericVector >(rcpp_result_gen);
    }

    inline NumericVector hnorm(int H, double mean = 0.0, double sd = 1.0, int prime = 3, int burn = 30) {
        typedef SEXP(*Ptr_hnorm)(SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_hnorm p_hnorm = NULL;
        if (p_hnorm == NULL) {
            validateSignature("NumericVector(*hnorm)(int,double,double,int,int)");
            p_hnorm = (Ptr_hnorm)R_GetCCallable("halton", "_halton_hnorm");
        }
        RObject rcpp_result_gen;
        {
            RNGScope RCPP_rngScope_gen;
            rcpp_result_gen = p_hnorm(Shield<SEXP>(Rcpp::wrap(H)), Shield<SEXP>(Rcpp::wrap(mean)), Shield<SEXP>(Rcpp::wrap(sd)), Shield<SEXP>(Rcpp::wrap(prime)), Shield<SEXP>(Rcpp::wrap(burn)));
        }
        if (rcpp_result_gen.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (Rcpp::internal::isLongjumpSentinel(rcpp_result_gen))
            throw Rcpp::LongjumpException(rcpp_result_gen);
        if (rcpp_result_gen.inherits("try-error"))
            throw Rcpp::exception(Rcpp::as<std::string>(rcpp_result_gen).c_str());
        return Rcpp::as<NumericVector >(rcpp_result_gen);
    }

    inline NumericVector hgamma(int H, double shape = 0, double scale = 1, int prime = 3, int burn = 30) {
        typedef SEXP(*Ptr_hgamma)(SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_hgamma p_hgamma = NULL;
        if (p_hgamma == NULL) {
            validateSignature("NumericVector(*hgamma)(int,double,double,int,int)");
            p_hgamma = (Ptr_hgamma)R_GetCCallable("halton", "_halton_hgamma");
        }
        RObject rcpp_result_gen;
        {
            RNGScope RCPP_rngScope_gen;
            rcpp_result_gen = p_hgamma(Shield<SEXP>(Rcpp::wrap(H)), Shield<SEXP>(Rcpp::wrap(shape)), Shield<SEXP>(Rcpp::wrap(scale)), Shield<SEXP>(Rcpp::wrap(prime)), Shield<SEXP>(Rcpp::wrap(burn)));
        }
        if (rcpp_result_gen.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (Rcpp::internal::isLongjumpSentinel(rcpp_result_gen))
            throw Rcpp::LongjumpException(rcpp_result_gen);
        if (rcpp_result_gen.inherits("try-error"))
            throw Rcpp::exception(Rcpp::as<std::string>(rcpp_result_gen).c_str());
        return Rcpp::as<NumericVector >(rcpp_result_gen);
    }

    inline NumericVector hlnorm(int H, double mean = 0.5, double sd = 0.25, int prime = 3, int burn = 30) {
        typedef SEXP(*Ptr_hlnorm)(SEXP,SEXP,SEXP,SEXP,SEXP);
        static Ptr_hlnorm p_hlnorm = NULL;
        if (p_hlnorm == NULL) {
            validateSignature("NumericVector(*hlnorm)(int,double,double,int,int)");
            p_hlnorm = (Ptr_hlnorm)R_GetCCallable("halton", "_halton_hlnorm");
        }
        RObject rcpp_result_gen;
        {
            RNGScope RCPP_rngScope_gen;
            rcpp_result_gen = p_hlnorm(Shield<SEXP>(Rcpp::wrap(H)), Shield<SEXP>(Rcpp::wrap(mean)), Shield<SEXP>(Rcpp::wrap(sd)), Shield<SEXP>(Rcpp::wrap(prime)), Shield<SEXP>(Rcpp::wrap(burn)));
        }
        if (rcpp_result_gen.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (Rcpp::internal::isLongjumpSentinel(rcpp_result_gen))
            throw Rcpp::LongjumpException(rcpp_result_gen);
        if (rcpp_result_gen.inherits("try-error"))
            throw Rcpp::exception(Rcpp::as<std::string>(rcpp_result_gen).c_str());
        return Rcpp::as<NumericVector >(rcpp_result_gen);
    }

    inline NumericMatrix mvhnormInv(int H, arma::rowvec means, arma::mat sigma, int burn = 30) {
        typedef SEXP(*Ptr_mvhnormInv)(SEXP,SEXP,SEXP,SEXP);
        static Ptr_mvhnormInv p_mvhnormInv = NULL;
        if (p_mvhnormInv == NULL) {
            validateSignature("NumericMatrix(*mvhnormInv)(int,arma::rowvec,arma::mat,int)");
            p_mvhnormInv = (Ptr_mvhnormInv)R_GetCCallable("halton", "_halton_mvhnormInv");
        }
        RObject rcpp_result_gen;
        {
            RNGScope RCPP_rngScope_gen;
            rcpp_result_gen = p_mvhnormInv(Shield<SEXP>(Rcpp::wrap(H)), Shield<SEXP>(Rcpp::wrap(means)), Shield<SEXP>(Rcpp::wrap(sigma)), Shield<SEXP>(Rcpp::wrap(burn)));
        }
        if (rcpp_result_gen.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (Rcpp::internal::isLongjumpSentinel(rcpp_result_gen))
            throw Rcpp::LongjumpException(rcpp_result_gen);
        if (rcpp_result_gen.inherits("try-error"))
            throw Rcpp::exception(Rcpp::as<std::string>(rcpp_result_gen).c_str());
        return Rcpp::as<NumericMatrix >(rcpp_result_gen);
    }

    inline arma::mat mvhnorm(int H, arma::rowvec means, arma::mat sigma, int burn = 30) {
        typedef SEXP(*Ptr_mvhnorm)(SEXP,SEXP,SEXP,SEXP);
        static Ptr_mvhnorm p_mvhnorm = NULL;
        if (p_mvhnorm == NULL) {
            validateSignature("arma::mat(*mvhnorm)(int,arma::rowvec,arma::mat,int)");
            p_mvhnorm = (Ptr_mvhnorm)R_GetCCallable("halton", "_halton_mvhnorm");
        }
        RObject rcpp_result_gen;
        {
            RNGScope RCPP_rngScope_gen;
            rcpp_result_gen = p_mvhnorm(Shield<SEXP>(Rcpp::wrap(H)), Shield<SEXP>(Rcpp::wrap(means)), Shield<SEXP>(Rcpp::wrap(sigma)), Shield<SEXP>(Rcpp::wrap(burn)));
        }
        if (rcpp_result_gen.inherits("interrupted-error"))
            throw Rcpp::internal::InterruptedException();
        if (Rcpp::internal::isLongjumpSentinel(rcpp_result_gen))
            throw Rcpp::LongjumpException(rcpp_result_gen);
        if (rcpp_result_gen.inherits("try-error"))
            throw Rcpp::exception(Rcpp::as<std::string>(rcpp_result_gen).c_str());
        return Rcpp::as<arma::mat >(rcpp_result_gen);
    }

}

#endif // RCPP_halton_RCPPEXPORTS_H_GEN_
